#ifndef AINetworkActionHandler_h
#define AINetworkActionHandler_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

class MapEditor;

class AINetworkActionHandler: public wxEvtHandler {
        
        DECLARE_CLASS(AINetworkActionHandler)
        
public:
	AINetworkActionHandler();
        virtual ~AINetworkActionHandler();
        
        static AINetworkActionHandler* GetInstance() {
                return &_instance;
        }
        
        void OnConnectNodesUnidirectional(wxCommandEvent& evt);
        void OnConnectNodesBidirectional(wxCommandEvent& evt);
        void OnMergeNodesAtFirst(wxCommandEvent& evt);
        void OnMergeNodesAtLast(wxCommandEvent& evt);
        void OnFlipUnidirectionalEdges(wxCommandEvent& evt);
        void OnSplitAtCenter(wxCommandEvent& evt);
protected:
        void DoConnectNodes(MapEditor* editor, bool bidirectional);
        
        static AINetworkActionHandler _instance;
};

#endif

