#ifndef AINetworkArcSelection_h
#define AINetworkArcSelection_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif
#include <Map/MapSelection.h>
#include <Map/MapDeltaDraggable.h>
#include "AINetworkArc.h"

class AINetworkArcSelection: public MapSelection, public MapDeltaDraggable {
        
        DECLARE_CLASS(AINetworkArcSelection)
        
public:
	AINetworkArcSelection(MapSelectionManager* manager, AINetworkArc* content);

        virtual ~AINetworkArcSelection();
        
        virtual bool Hit(Point3D p);
        
        virtual wxRect GetDeviceBounds() const;
        
        virtual void ProvideActionMenuForClass(wxMenu& actionMenu, wxClassInfo* targetClass);
        
        virtual void StartDrag(Point3D currentPosition) { MapDeltaDraggable::StartDrag(currentPosition); }
        
        virtual void Drag(Point3D currentPosition) { MapDeltaDraggable::Drag(currentPosition); }
        
        virtual void DeltaDrag(Point3D delta);
        
        virtual wxString EndDrag();
        
        virtual void Paint(wxDC& dc);
        
        virtual void ProvidePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void UpdatePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void MarkDifferingPropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass, MapSelection* firstSelection);
        
        virtual void UpdateObjectFromProperty(wxPGProperty* property);

        AINetworkArc* GetContent() const { return wxDynamicCast(MapSelection::GetContent(),AINetworkArc); }
};

#endif


