#ifndef BeaconSelection_h
#define BeaconSelection_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif
#include "PointObjectSelection.h"
#include "BeaconMapObject.h"


class BeaconSelection: public PointObjectSelection {
        
        DECLARE_CLASS(BeaconSelection)
        
public:
	BeaconSelection(MapSelectionManager* manager, BeaconMapObject* content);

        virtual ~BeaconSelection();
        
        virtual wxString EndDrag() {
                return wxT("Moving Beacon");
        }

        virtual void ProvidePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void UpdatePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void MarkDifferingPropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass, MapSelection* firstSelection);
        
        virtual void UpdateObjectFromProperty(wxPGProperty* property);

        BeaconMapObject* GetContent() const { return wxDynamicCast(PointObjectSelection::GetContent(),BeaconMapObject); }
};

#endif


