#ifndef RunwaySelection_h
#define RunwaySelection_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif
#include "PavementSelection.h"
#include "RunwayMapObject.h"


class RunwaySelection: public PavementSelection {
        
        DECLARE_CLASS(RunwaySelection)
        
public:
	RunwaySelection(MapSelectionManager* manager, RunwayMapObject* content);

        virtual ~RunwaySelection();

        virtual MapSelectionHandle* HitHandle(Point3D p);
        
        virtual wxString EndDrag() {
                return wxT("Moving Runway");
        }
        
        virtual void ProvidePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void UpdatePropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass);
        
        virtual void MarkDifferingPropertiesForClass(wxPropertyGrid* propgrid, wxClassInfo* targetClass, MapSelection* firstSelection);
        
        virtual void UpdateObjectFromProperty(wxPGProperty* property);

        RunwayMapObject* GetContent() const { return wxDynamicCast(PavementSelection::GetContent(),RunwayMapObject); }
protected:
        void ProvideRunwayEndProperties(wxPropertyGrid* propgrid,
                                         const wxString idPrefix);
        void UpdateRunwayEndProperties(wxPropertyGrid* propgrid,
                                         const wxString idPrefix,
                                         RunwayMapObject::RunwayEndData rwyEndData);
        void MarkDifferingRunwayEndProperties(wxPropertyGrid* propgrid,
                                                const wxString idPrefix,
                                                RunwayMapObject::RunwayEndData myRwyEndData,
                                                RunwayMapObject::RunwayEndData firstRwyEndData);
        bool UpdateRunwayEndFromProperty(wxPGProperty* property,
                                         const wxString idPrefix,
                                         RunwayMapObject::RunwayEndData &rwyEndData);
};

#endif


