#ifndef OldProjectLoader_h
#define OldProjectLoader_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Airport/Airport.h>
#include <Map/MapObjectContainer.h>

#include <iostream>

#include <wx/progdlg.h>

class TransactionManager;

class OldProjectLoader: public wxObject {
        
        DECLARE_CLASS(OldProjectLoader)
        
public:
	OldProjectLoader(TransactionManager *tmgr,
                         std::istream& infile);
        virtual ~OldProjectLoader();
        
        Airport::SmartRef LoadProject(wxProgressDialog* progdlg,
                                      wxString& projection,
                                      MapObjectContainer::SmartRef backgroundImageLayer);
protected:
        void LoadCalibratedBackgroundImage(wxProgressDialog* progdlg,
                                           wxString& projection,
                                           MapObjectContainer::SmartRef backgroundImageLayer);
        void LoadGroundNetwork(wxString& groundNetPath);
        
        TransactionManager *_transactionManager;
        std::istream& _infile;
};

#endif

