#ifndef OldProjectWriter_h
#define OldProjectWriter_h

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Airport/Airport.h>
#include <Imagery/MapCalibratedBackgroundImage.h>

#include <iostream>

class MapObjectContainer;
class MapProjection;

class OldProjectWriter: public wxObject {
        
        DECLARE_CLASS(OldProjectWriter)
        
public:
	OldProjectWriter(std::ostream& outfile);
        virtual ~OldProjectWriter();
        
        void writeProject(Airport::SmartRef airport,
                          MapProjection* projection,
                          MapObjectContainer* backgroundImageLayer);
        void writeCalibration(MapCalibratedBackgroundImage::SmartRef backgroundImage,
                              MapProjection* projection);
        void writeAirport(Airport::SmartRef airport);
protected:
        std::ostream& _outfile;
};

#endif

