#include "MapStatusBar.h"

IMPLEMENT_CLASS(MapStatusBar,wxStatusBar);

BEGIN_EVENT_TABLE(MapStatusBar, wxStatusBar)
        EVT_SIZE(MapStatusBar::OnSize)
END_EVENT_TABLE()

MapStatusBar::MapStatusBar():
        wxStatusBar(),
        _done(0),
        _total(0)
{
        Setup();
}

MapStatusBar::MapStatusBar(wxWindow* parent, wxWindowID id, long style, const wxString& name):
        wxStatusBar(parent,id,style,name),
        _done(0),
        _total(0)
{
        Setup();
}

MapStatusBar::~MapStatusBar() {
}

void MapStatusBar::Setup() {
        _gaugeSizer=new wxBoxSizer(wxHORIZONTAL);
        _gauge=new wxGauge(this,wxID_ANY,0);
        _gaugeText=new wxStaticText(this,wxID_ANY,wxT(""),wxDefaultPosition,wxDefaultSize,wxALIGN_LEFT);
        
        _gaugeSizer->Add(_gaugeText,wxSizerFlags().Left().Expand().Proportion(0));
        _gaugeSizer->Add(_gauge,wxSizerFlags().Left().Expand().Proportion(1));
        
        ShowProgress(false);
}

void MapStatusBar::OnSize(wxSizeEvent& evt) {
        wxRect rect;
        evt.Skip();
        if (GetFieldsCount()!=3 || !GetFieldRect(2,rect)) {
                return;
        }
        _gaugeSizer->SetDimension(rect.GetLeft(),rect.GetTop(),rect.GetWidth(),rect.GetHeight());
        _gaugeSizer->Layout();
}

void MapStatusBar::SetProgressLabel(const wxString& label) {
        _gaugeLabel=label;
        UpdateProgressText();
}

void MapStatusBar::SetProgress(int done, int total) {
        _total=total;
        _done=done;
        _gauge->SetRange(total);
        _gauge->SetValue(done);
        UpdateProgressText();
        ShowProgress(total!=0);
}

void MapStatusBar::UpdateProgressText() {
        wxString text;
        
        text.Printf(wxT("%3d/%3d"),_done,_total);
        _gaugeText->SetLabel(_gaugeLabel+wxT(" ")+text);
        _gaugeSizer->Layout();
}

void MapStatusBar::ShowProgress(bool show) {
        _gauge->Show(show);
        _gaugeText->Show(show);
        SetFieldsCount(2+(show?1:0));
        if (show) {
                wxRect rect;
                GetFieldRect(2,rect);
                _gaugeSizer->SetDimension(rect.GetLeft(),rect.GetTop(),rect.GetWidth(),rect.GetHeight());
                _gaugeSizer->Layout();
        }
}
