#if HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

#include "ModifyMode.h"
#include <Map/MapEditor.h>
#include <Map/MapCoordinateSystem.h>
#include <Map/MapDraggable.h>
#include <Map/MapSelection.h>
#include <Map/MapSelectionManager.h>
#include <Map/MapSelectionHandle.h>

IMPLEMENT_CLASS(ModifyMode,Mode)

BEGIN_EVENT_TABLE(ModifyMode,Mode)
        EVT_LEFT_DOWN(ModifyMode::OnLeftButtonDown)
        EVT_MOTION(ModifyMode::OnMouseMotion)
        EVT_LEFT_UP(ModifyMode::OnLeftButtonUp)
END_EVENT_TABLE()

void ModifyMode::OnLeftButtonDown(wxMouseEvent& evt) {
        MapSelectionManager* selmgr=&GetEditor()->GetSelectionManager();

        Point3D p;
        p=GetEditor()->GetCoordinateSystem().DeviceToLogical(evt.GetPosition());
        _currentDraggable=selmgr->HitHandle(p);
        if (!_currentDraggable)
                _currentDraggable=selmgr;
        _currentDraggable->StartDrag(p);
        _wasDragged=false;
}

void ModifyMode::OnMouseMotion(wxMouseEvent& evt) {
        Point3D p;

        _wasDragged=true;
        p=GetEditor()->GetCoordinateSystem().DeviceToLogical(evt.GetPosition());
        _currentDraggable->Drag(p);
}

void ModifyMode::OnLeftButtonUp(wxMouseEvent& evt) {
        if (_wasDragged)
                GetEditor()->GetTransactionManager()->Commit(_currentDraggable->EndDrag());
        else
                GetEditor()->GetTransactionManager()->Commit(_defaultDescription);
        Done();
}

void ModifyMode::Leave(bool force) {
        if (force) {
                if (_currentDraggable)
                        _currentDraggable->EndDrag();
                GetEditor()->GetTransactionManager()->Abort();
        }
        Mode::Leave(force);
}
