// OSGB36Projection.hxx - A class to encapsulate the UK OSGB36 projection.
//
// Written by David Luff, started 2003.
//
// Copyright (C) 2002  David C Luff - david.luff@nottingham.ac.uk
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef _OSGB36_PROJECTION_HXX
#define _OSGB36_PROJECTION_HXX

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

#include <Map/MapProjection.h>

class OSGB36Projection : public MapProjection {
        DECLARE_DYNAMIC_CLASS(OSGB36Projection)
        
public:
        OSGB36Projection();
        ~OSGB36Projection();
        
        bool Init(Point3D centre);
        
        Point3D ConvertToLocal(Point3D pt);
        
        Point3D ConvertFromLocal(Point3D pt);

    static void RegisterProjections();
private:
        Point3D origin;
        
};

#endif	// _OSGB36_PROJECTION_HXX
